<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <title>JSDoc: Source: mtlg.js</title>

    <script src="scripts/prettify/prettify.js"> </script>
    <script src="scripts/prettify/lang-css.js"> </script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc-default.css">
</head>

<body>

<div id="main">

    <h1 class="page-title">Source: mtlg.js</h1>

    



    
    <section>
        <article>
            <pre class="prettyprint source linenums"><code>/**
 * @Author: Thiemo Leonhardt &lt;thiemo>
 * @Date:   2017-08-17T19:26:38+02:00
 * @Email:  leonhardt@cs.rwth-aachen.de
 * @Last modified by:   thiemo
 * @Last modified time: 2017-08-17T19:30:03+02:00
 */

/**
 * MTLG framework
 *
 * @namespace MTLG
 *
 **/
var MTLG = (function() {


  /*
   * Programmvariablen (Initialisierung weiter unten)
   */
  var stage,
    data,
    intlData,
    optionen,
    abschnittIndex,
    spieler,
    moduleInit,
    blockingModules,
    gameInit;

  /*
   * Diese Funktion initialisiert das Lernspiel
   * Sie wird beim onload-Event des body der index.html aufgerufen
   */
  var mtlg_init = function() {
    /*
     * Default-Optionen
     * Sprache wird wie folgt gesetzt:
     * 1. Sind Sprachen im Browser definiert?
     * 2. Wenn ja, nimm die oberste Sprache - Ende
     * 3. Wenn nein, nimm die Nutzer präferenzierte Sprache - Ende
     */
    optionen = optionen || {};
    defaults = {
      breite: screen.width,
      hoehe: screen.height,
      zoll: 27,
      countdown: 180,
      fps: 60,
      spielerzahl: 4,
      mockLogin: false, //Skip login and use dummies instead
      mockNumber: 4 //Number of dummies created
    };



    /*
     * Wenn keine Parameter angegeben werden, default Werte benutzen
     */

    for (var prop in defaults) {
      if (prop in optionen) {
        continue;
      }
      optionen[prop] = defaults[prop];
    }

    /*
     * Set the language for the game:
     * First try to find language setting (set in device_manifest)
     * Next try to set the browser prefered language as game language.
     * Choose the first available language else.
     */
    if (!optionen.language || !MTLG.lang.setLanguage(optionen.language)) {
      console.log("Device manifest language could not be set: " + optionen.language);
      var browserLang = navigator.languages ? navigator.languages[0] : navigator.language;
      browserLang = browserLang.split("-")[0];
      if (!MTLG.lang.setLanguage(browserLang)) {
        console.log("Browser language " + browserLang + " not supported!");
        MTLG.lang.setLanguage(optionen.languages[0]);
      }
    }

    //Passe das canvasObjekt den Vorgaben aus den Optionen an:
    var canvas = document.getElementById('canvasObjekt');
    canvas.setAttribute('width', optionen.breite);
    canvas.setAttribute('height', optionen.hoehe);

    //Weise das CanvasObjekt zu
    stage = new createjs.Stage(canvas);
    //Erlaube touchen
    createjs.Touch.enable(stage);

    spieler = [];

    //Initialize modules
    moduleInit = moduleInit || []; //Make sure this works even if no module was registered
    blockingModules = {}; //Some modules have to be present before the game starts
    for (var i = 0; i &lt; moduleInit.length; i++) {
      try {
        var retValue = (moduleInit[i])(optionen, moduleCallback);
        if (retValue) { //Blocking modules return their handle
          blockingModules[retValue] = true;
        }
      } catch (err) {
        console.log("Error calling init function: ");
        console.log(err);
        console.log(moduleInit[i]);
      }
    }

    //Initialize game
    try {
      gameInit(optionen);
    } catch (err) {
      console.log("Error calling game init function: ");
      console.log(err);
      console.log(gameInit);
    }
  }

  /**
   * This function is callec by blocking modules once they are done.
   * If all blocking modules are finished, this function calls allModulesDone.
   * @param moduleHandle the handle, as specified in the return value of the module init function
   */
  function moduleCallback(moduleHandle) {
    if (blockingModules[moduleHandle]) {
      blockingModules[moduleHandle] = false;
    } else {
      console.log("Callback from unknown module: " + moduleHandle);
    }
    var modulesLeft = false;
    for (var property in blockingModules) {
      if (blockingModules.hasOwnProperty(property)) {
        if (blockingModules[property]) {
          modulesLeft = true;
          break;
        }
      }
    }
    if (!modulesLeft) {
      allModulesDone();
    }
  }

  /**
   * This function is called after all modules have been initialized.
   * It starts the game and stage update ticker.
   */
  function allModulesDone() {
    console.log("All modules loaded");
    //Beginne das Spiel
    createjs.Ticker.setFPS(optionen.fps);
    createjs.Ticker.addEventListener('tick', stage);
    //Call zumHauptmenue() for backwards compatibility
    if (MTLG.lc.getLevels().length &lt;= 0) {
      zumHauptmenue(); //Spiel kümmert sich um login- Aufrufe
    } else {
      MTLG.lc.startGame(); //lc takes care of login etc.
    }

  };

  // resize all canvas overlays
  function resize_canvas(stage) {
    var canvas = document.getElementsByTagName('canvas'),
      i;
    for (i = 0; i &lt; canvas.length; i = i + 1) {
      canvas[i].height = window.innerHeight;
      canvas[i].width = window.innerWidth;
    }
  }

  /**
   * Add an initialization callback for a module.
   * This will be called in MTLG.init().
   */
  function addModule(initCallback) {
    moduleInit = moduleInit || [];
    moduleInit.push(initCallback);
  }

  /**
   * This function is used to register the game init function with the MTLG framework.
   * It should be called in the game js file.
   */
  function addGameInit(initCallback) {
    gameInit = initCallback;
  }



  //////////////////////////////////////


  /*
   * Diese Funktion wird am Ende eines Abschnittes aufgerufen und startet den naechsten
   */
  var geheZumNaechstenAbschnitt = function() {
    //If the lc is used call levelFinished (without a gameState!)
    if (MTLG.lc.getLevels().length >= 1) {
      MTLG.lc.levelFinished();
    } else { //Old way
      switch (abschnittIndex) {
        case 0:
          abschnittIndex++;
          Spiel.login_init();
          break;
        case 1:
          abschnittIndex++;
          Spiel.spielfeld_init();
          break;
        case 2:
          abschnittIndex++;
          Spiel.feedback_init();
          zeichneFeedbackOptionen();
          break;
        default:
          console.log('Keine gültige Eingabe beim aktuellen Feld!');
      }
    }

  };

  /*
   * Diese Funktion erlaubt an jeder Stelle des Spiels die Rueckkehr ins Hauptmenue
   */
  var zumHauptmenue = function() {
    //Try to use lifecycle manager
    if (MTLG.lc.hasMenu()) {
      MTLG.lc.goToMenu();
    } else { // Use old version for backwards compatibility if no menu exists
      stage.removeAllChildren();
      abschnittIndex = 0;
      Spiel.zeichneHauptmenue();
    }
  };


  ////////////////////////


  /*
   * Diese Funktion zeichnet die Feedbackoptionen
   * Da es nur einen Bereich fuer das Feedback gibt, ist kein Parameter noetig
   */
  var zeichneFeedbackOptionen = function() {
    var hit = new createjs.Shape();
    hit.graphics.beginFill('black').drawRect(0, 0, 300, 150);

    var button = new createjs.Bitmap('./img/menueButton.png');
    button.x = 10;
    button.y = optionen.hoehe - 160;
    button.image.onload = function() {
      stage.update();
    };
    button.hitArea = hit;
    button.addEventListener('click', function(event) {
      abschnittIndex = 1;
      geheZumNaechstenAbschnitt();
    });

    var text = '{{NeuesSpiel}}'
    var template = Handlebars.compile(text);
    var buttonText = new createjs.Text(template(data), '30px Arial', 'yellow');
    buttonText.x = (160 - (buttonText.getMeasuredWidth() / 2));
    buttonText.y = button.y + ((150 - buttonText.getMeasuredHeight()) / 2);

    var hit2 = new createjs.Shape();
    hit2.graphics.beginFill('black').drawRect(0, 0, 300, 150);

    var hmbutton = new createjs.Bitmap('./img/menueButton.png');
    hmbutton.x = button.x + 300 + 25;
    hmbutton.y = button.y;
    hmbutton.image.onload = function() {
      stage.update();
    };
    hmbutton.hitArea = hit2;
    hmbutton.addEventListener('click', function(event) {
      zumHauptmenue();
    });

    text = '{{Menuetext_ZumHauptmenue}}';
    template = Handlebars.compile(text);
    var hmText = new createjs.Text(template(data), '30px Arial', 'yellow');
    hmText.x = (hmbutton.x + 150 - (hmText.getMeasuredWidth() / 2));
    hmText.y = (hmbutton.y + ((150 - hmText.getMeasuredHeight()) / 2));

    stage.addChild(button);
    stage.addChild(buttonText);
    stage.addChild(hmbutton);
    stage.addChild(hmText);
    stage.update();
  };


  /////////////////////////////////

  /*
   * Diese Funktion gibt das stageObjekt zurueck
   */
  var gibStage = function() {
    return stage;
  };

  var loadOptions = function(newOptions) {
    optionen = optionen || {};
    //Override local settings if existing
    for (var prop in newOptions) {
      optionen[prop] = newOptions[prop];
    }
  }

  /*
   * Diese Funktion liefert die Anzahl der Spieler
   */
  var gibSpielerAnzahl = function() {
    return spieler.length;
  };

  /*
   * Diese Funktion fuegt Spieler hinzu und gibt dessen Index zurueck
   * @param neuerSpieler: Das zu ergaenzende Spielerobjekt
   */
  var neuerSpieler = function(neuerSpieler) {
    spieler.push(neuerSpieler);
    return spieler.lastIndexOf;
  };

  /*
   * Diese Funktion gibt einen spezifizierten Spieler zurueck
   * @param index: Der Index des Spielers
   */
  var gibSpieler = function(index) {
    return spieler[index];
  };

  /**
   * Diese Funktion entfernt die derzeitigen Spieler aus dem array (und somit dem Spiel)
   */
  var entferneAlleSpieler = function(index) {
    spieler = [];
  }

  /*
   * Diese Funktion gibt den Namen eines spezifizierten Spielers zurueck
   * @param index: Der Index des Spielers
   */
  var gibSpielerName = function(index) {
    return spieler[index].name;
  };

  /*
   * Diese Funktion gibt das optionen-Attribut zurueck
   */
  var gibOptionen = function() {
    return optionen;
  };

  /*
   * Diese Funktion rechnet rotierte Koordinaten um
   * @param bereich: Der Bereich, in dem gezeichnet wird
   * @param Ox: Die gedachte Stelle mit x = 0
   * @param Oy: Die gedachte Stelle mit y = 0
   */
  var berechneKoordianten = function(bereich, x, y) {
    //Check if rotation matrix exists in bereich
    if (!bereich.toGlobalMatrix) {
      bereich.toGlobalMatrix = {};
      bereich.toGlobalMatrix.x1 = Math.cos(-bereich.rotation * (Math.PI / 180)); //Need to convert to rad
      bereich.toGlobalMatrix.x2 = Math.sin(-bereich.rotation * (Math.PI / 180)); //Negative alpha because positive rotation is rotating clockwise
      bereich.toGlobalMatrix.y1 = -Math.sin(-bereich.rotation * (Math.PI / 180)); //Need to rotate back (counter-clockwise)
      bereich.toGlobalMatrix.y2 = Math.cos(-bereich.rotation * (Math.PI / 180)); //Thus it transforms a vector in bereich rotation to global rotation
    }
    return {
      xKoord: bereich.toGlobalMatrix.x1 * x + bereich.toGlobalMatrix.x2 * y + bereich.Ox,
      yKoord: bereich.toGlobalMatrix.y1 * x + bereich.toGlobalMatrix.y2 * y + bereich.Oy
    };
  };

  /*
   * Diese Funktion rechnet globale in lokale Koordinaten um.
   */
  var toLocal = function(bereich, x, y) {
    //Check if rotation matrix exists in bereich
    if (!bereich.toLocalMatrix) {
      bereich.toLocalMatrix = {};
      bereich.toLocalMatrix.x1 = Math.cos(bereich.rotation * (Math.PI / 180)); //Need to convert to rad
      bereich.toLocalMatrix.x2 = Math.sin(bereich.rotation * (Math.PI / 180)); //Positive alpha because positive rotation is rotating clockwise
      bereich.toLocalMatrix.y1 = -Math.sin(bereich.rotation * (Math.PI / 180));
      bereich.toLocalMatrix.y2 = Math.cos(bereich.rotation * (Math.PI / 180)); //Thus it transforms a vector in global rotation to local rotation
    }
    //global Coord - upper left to receive vector from UL to global, then rotate that vector to receive coords in local
    return {
      xKoord: bereich.toLocalMatrix.x1 * (x - bereich.Ox) + bereich.toLocalMatrix.x2 * (y - bereich.Oy),
      yKoord: bereich.toLocalMatrix.y1 * (x - bereich.Ox) + bereich.toLocalMatrix.y2 * (y - bereich.Oy)
    };
  }

  /*
   * Diese Funktion skaliert den übergebenen user- Bereich auf (nicht um!) die übergebene Prozentzahl
   * TODO: Zur Zeit skaliert es um die übergeben Prozentzahl
   * Assertions: bereich ist rechteckig, von der Mitte weg gedreht
   */
  var scaleUser = function(bereich, faktor) {
    //Idee:
    //Erst nach unten links shrinken, gucken ob nach rechts geschobenes Zentrum weiter von Mitte weg ist?schieben:lassen
    if (!bereich) return undefined; //Leere bereiche

    var scale = Math.sqrt(faktor); //Jede Seite des Bereiches wird um diesen Faktor skaliert
    var oldWidth = bereich.breite;
    var oldHeight = bereich.hoehe;
    bereich.breite = bereich.breite * scale;
    bereich.hoehe = bereich.hoehe * scale;
    bereich.skalierungsfaktor = faktor;

    var newO = berechneKoordianten(bereich, 0, oldHeight - bereich.hoehe);
    bereich.Ox = newO.xKoord; //Set these first so that berechneKoordinaten works
    bereich.Oy = newO.yKoord;
    var middle1 = berechneKoordianten(bereich, bereich.breite / 2, bereich.hoehe / 2);
    middle1.xKoord -= optionen.breite / 2;
    middle1.yKoord -= optionen.hoehe / 2;
    var middle2 = berechneKoordianten(bereich, (oldWidth - bereich.breite) + bereich.breite / 2, bereich.hoehe / 2);
    middle2.xKoord -= optionen.breite / 2;
    middle2.yKoord -= optionen.hoehe / 2;
    var length1 = Math.sqrt(Math.pow(middle1.xKoord, 2) + Math.pow(middle1.yKoord, 2));
    var length2 = Math.sqrt(Math.pow(middle2.xKoord, 2) + Math.pow(middle2.yKoord, 2));
    if (length2 > length1) {
      var newO = berechneKoordianten(bereich, oldWidth - bereich.breite, 0);
      bereich.Ox = newO.xKoord;
      bereich.Oy = newO.yKoord;
    }



  }


  /*
   * Diese Funktion berechnet einen größt-möglichen freien Bereich auf der Stage,
   * der in der Mitte plaziert werden kann,
   * unter Einbeziehung der übergebenen Bereiche
   */
  var getBiggestFreeArea = function(bereiche) {
    var biggestFree = {
      xl: 0,
      xr: optionen.breite,
      yu: 0,
      yl: optionen.hoehe
    };
    var middle = {
      x: optionen.breite / 2,
      y: optionen.hoehe / 2
    };
    var comp1;
    var comp2;

    //Cut away from biggest Free
    var i = 0;
    //Each loop step looks at one bereich and cuts on one axis to ensure that the bereich is not part of biggestFree
    for (i = 0; i &lt; bereiche.length; i++) {
      var bereich = bereiche[i];
      comp1 = berechneKoordianten(bereich, bereich.breite / 2, bereich.hoehe / 2);
      comp2 = berechneKoordianten(bereich, bereich.breite, bereich.hoehe);
      if (Math.abs(comp1.xKoord - middle.x) > Math.abs(comp1.yKoord - middle.y)) { //If comp1 is closer to middle on y-axis we cut on x-axis
        if (comp1.xKoord > middle.x) { //Right
          for (var j = 0; j &lt; 2; j++) {
            for (var k = 0; k &lt; 2; k++) {
              if (biggestFree.xr > berechneKoordianten(bereich, j * bereich.breite, k * bereich.hoehe).xKoord) {
                biggestFree.xr = berechneKoordianten(bereich, j * bereich.breite, k * bereich.hoehe).xKoord;
              }
            }
          }
        }
        if (comp1.xKoord &lt; middle.x) { //Left
          for (var j = 0; j &lt; 2; j++) {
            for (var k = 0; k &lt; 2; k++) {
              if (biggestFree.xl &lt; berechneKoordianten(bereich, j * bereich.breite, k * bereich.hoehe).xKoord) {
                biggestFree.xl = berechneKoordianten(bereich, j * bereich.breite, k * bereich.hoehe).xKoord;
              }
            }
          }
        }
        //TODO: Dont cut anything if bereich is right in the center?
      } else { //comp1 is closer to x axis
        if (comp1.yKoord &lt; middle.y) { //Upper
          for (var j = 0; j &lt; 2; j++) {
            for (var k = 0; k &lt; 2; k++) {
              if (biggestFree.yu &lt; berechneKoordianten(bereich, j * bereich.breite, k * bereich.hoehe).yKoord) {
                biggestFree.yu = berechneKoordianten(bereich, j * bereich.breite, k * bereich.hoehe).yKoord;
              }
            }
          }
        }
        if (comp1.yKoord > middle.y) { //Lower
          for (var j = 0; j &lt; 2; j++) {
            for (var k = 0; k &lt; 2; k++) {
              if (biggestFree.yl > berechneKoordianten(bereich, j * bereich.breite, k * bereich.hoehe).yKoord) {
                biggestFree.yl = berechneKoordianten(bereich, j * bereich.breite, k * bereich.hoehe).yKoord;
              }
            }
          }
        }
      }
    }

    return biggestFree;
  }


  /**
   * Function to create user areas.
   * @param numberOfPlayers: number of areas created
   */
  function bereicheErstellen(numberOfPlayers) {
    var fensterBreite = MTLG.gibOptionen().breite; //ctx.width;
    var fensterHoehe = MTLG.gibOptionen().hoehe; //ctx.height;
    var bereiche = new Array();

    // 0 = einzel, 1= zweier, 2= vierer, 3= vierer-rotiert, 4= achter
    switch (numberOfPlayers) {
      case 1: //Ein Benutzer
        var bildschirm1 = {
          Ox: 0,
          Oy: 0,
          rotation: 0,
          breite: fensterBreite,
          hoehe: fensterHoehe,
          index: 0
        };
        bereiche.push(bildschirm1);
        break;

      case 2: //Zwei Benutzer
        var bildschirm1 = {
          Ox: (fensterBreite / 2),
          Oy: 0,
          rotation: 90,
          breite: fensterHoehe,
          hoehe: (fensterBreite / 2),
          index: 0
        };
        var bildschirm2 = {
          Ox: (fensterBreite / 2),
          Oy: fensterHoehe,
          rotation: -90,
          breite: fensterHoehe,
          hoehe: (fensterBreite / 2),
          index: 1
        };
        bereiche.push(bildschirm1);
        bereiche.push(bildschirm2);
        break;

      case 4: //Vier Benutzer
        var bildschirm1 = {
          Ox: (fensterBreite / 2),
          Oy: (fensterHoehe / 2),
          rotation: 180,
          breite: (fensterBreite / 2),
          hoehe: (fensterHoehe / 2),
          index: 0
        };
        var bildschirm2 = {
          Ox: fensterBreite,
          Oy: (fensterHoehe / 2),
          rotation: 180,
          breite: (fensterBreite / 2),
          hoehe: (fensterHoehe / 2),
          index: 1
        };
        var bildschirm3 = {
          Ox: 0,
          Oy: (fensterHoehe / 2),
          rotation: 0,
          breite: (fensterBreite / 2),
          hoehe: (fensterHoehe / 2),
          index: 2
        };
        var bildschirm4 = {
          Ox: (fensterBreite / 2),
          Oy: (fensterHoehe / 2),
          rotation: 0,
          breite: (fensterBreite / 2),
          hoehe: (fensterHoehe / 2),
          index: 3
        };
        bereiche.push(bildschirm1);
        bereiche.push(bildschirm2);
        bereiche.push(bildschirm3);
        bereiche.push(bildschirm4);
        break;

      case 8: //8 Benutzer
        var bereichsHoehe = fensterHoehe / (2 + (9 / 9) * (1 + Math.sqrt(2)));
        var bereichsBreite = (9 / 9) * bereichsHoehe;
        var koordOff = bereichsBreite * Math.cos(Math.PI / 4);
        var bildschirm1 = {
          Ox: (fensterBreite / 2 - bereichsBreite / 2),
          Oy: (bereichsHoehe),
          rotation: 135,
          breite: bereichsBreite,
          hoehe: bereichsHoehe,
          index: 0
        };
        var bildschirm2 = {
          Ox: (fensterBreite / 2 + bereichsBreite / 2),
          Oy: (bereichsHoehe),
          rotation: 180,
          breite: bereichsBreite,
          hoehe: bereichsHoehe,
          index: 1
        };
        var bildschirm3 = {
          Ox: (fensterBreite / 2 + bereichsBreite / 2 + koordOff),
          Oy: (bereichsHoehe + koordOff),
          rotation: 225,
          breite: bereichsBreite,
          hoehe: bereichsHoehe,
          index: 2
        };
        var bildschirm4 = {
          Ox: (fensterBreite / 2 + bereichsBreite / 2 + koordOff),
          Oy: (fensterHoehe / 2 + bereichsBreite / 2),
          rotation: 270,
          breite: bereichsBreite,
          hoehe: bereichsHoehe,
          index: 3
        };
        var bildschirm5 = {
          Ox: (fensterBreite / 2 + bereichsBreite / 2),
          Oy: (fensterHoehe - bereichsHoehe),
          rotation: 315,
          breite: bereichsBreite,
          hoehe: bereichsHoehe,
          index: 4
        };
        var bildschirm6 = {
          Ox: (fensterBreite / 2 - bereichsBreite / 2),
          Oy: (fensterHoehe - bereichsHoehe),
          rotation: 0,
          breite: bereichsBreite,
          hoehe: bereichsHoehe,
          index: 5
        };
        var bildschirm7 = {
          Ox: (fensterBreite / 2 - bereichsBreite / 2 - koordOff),
          Oy: (fensterHoehe - bereichsHoehe - koordOff),
          rotation: 45,
          breite: bereichsBreite,
          hoehe: bereichsHoehe,
          index: 6
        };
        var bildschirm8 = {
          Ox: (fensterBreite / 2 - bereichsBreite / 2 - koordOff),
          Oy: (fensterHoehe / 2 - bereichsBreite / 2),
          rotation: 90,
          breite: bereichsBreite,
          hoehe: bereichsHoehe,
          index: 7
        };
        bereiche.push(bildschirm1);
        bereiche.push(bildschirm2);
        bereiche.push(bildschirm3);
        bereiche.push(bildschirm4);
        bereiche.push(bildschirm5);
        bereiche.push(bildschirm6);
        bereiche.push(bildschirm7);
        bereiche.push(bildschirm8);
        break;
      default:
        console.log("Currently unsupported number of players: " + numberOfPlayers);
        break;
    }
    return bereiche;
  }

  /**
   * This function prints the progress onto the canvas.
   * Progress should be in [0,1].
   */
  function drawProgress(progress) {
    stage.removeAllChildren();

    //Grey bg Rect
    var barBg = new createjs.Shape();
    var width = (optionen.breite * 0.5);
    barBg.graphics.beginFill('#f0f0f0').drawRect(0, 0, (width), optionen.hoehe / 25);
    barBg.regX = 0;
    barBg.regY = optionen.hoehe / 50;
    barBg.x = optionen.breite / 4;
    barBg.y = optionen.hoehe / 2;

    //Orange progress rect
    var barFg = new createjs.Shape();
    var width = (optionen.breite * 0.5) * progress;
    barFg.graphics.beginFill('#ffa500').drawRect(0, 0, (width), optionen.hoehe / 25);
    barFg.regX = 0;
    barFg.regY = optionen.hoehe / 50;
    barFg.x = optionen.breite / 4;
    barFg.y = optionen.hoehe / 2;

    stage.addChild(barBg);
    stage.addChild(barFg);
    stage.update();
  }


  /////////////////////////////////////



  //Diese Variable zählt die Sekunden, die das Spiel am Stueck keine Interaktionen wahrnimmt
  var zaehler = 0;

  /*
   * Diese Funktion legt fest, welche Interaktionen den zaehler reseten und
   * setzt auch den Timer, der den zaehler jede Sekunde um eins erhoeht
   */
  var resetTimer_init = function() {
    (document.all) ? document.onmousemove = resetResetTimer: window.onmousemove = resetResetTimer;
    (document.all) ? document.onkeypress = resetResetTimer: window.onkeypress = resetResetTimer;
    (document.all) ? document.onclick = resetResetTimer: window.onclick = resetResetTimer;
    (document.all) ? document.ontouchmove = resetResetTimer: window.ontouchmove = resetResetTimer;
    (document.all) ? document.ontouchstart = resetResetTimer: window.ontouchstart = resetResetTimer;

    resetResetTimer();
    window.setInterval(function() {
      erhoeheZaehler();
    }, 1000);
  };

  /*
   * Register the reset Timer with the MTLG framework.
   * This is in the same scope as MTLG.
   */
  addModule(resetTimer_init);

  /*
   * Setzt den zaehler wieder auf 0
   */
  var resetResetTimer = function() {
    zaehler = 0;
  };

  /*
   * Erhoeht den zaehler und reagiert, wenn noetig, auf den timeout
   */
  var erhoeheZaehler = function() {
    zaehler = parseInt(zaehler) + 1;
    if (zaehler === optionen.resetCountdown + 1) {
      Spiel.neustart_init();
      resetResetTimer();
    }
  };



  ////////////////


  /*
   * Diese Variablen verwalten die Pfade zu den Ordnern mit den Audiodateien
   * und Listen der bereits geladenen Dateien
   */
  var sprachSounds,
    allgemeineSounds,
    sprachSoundsPfad,
    allgemeineSoundsPfad;

  /*
   * Diese Funktion initialisiert das Soundabspielen
   * Sollte der Browser das Wiedergeben von Audiodateien nicht unterstuetzen, wird eine entsprechende Warnung ausgegeben
   */
  var soundsLaden = function() {
    //Kann der Browser Sounds wiedergeben
    if (!createjs.Sound.initializeDefaultPlugins()) {
      alert('Das Soundplugin konnte nicht initialisiert werden');
      return;
    }

    sprachSoundsPfad = './sounds/' + optionen.sprache + '/';
    allgemeineSoundsPfad = './sounds/_allgemein/';

    sprachSounds = [];

    allgemeineSounds = [];
  };

  //Register the sound init function with the MTLG framework
  //This is in the same scope as MTLG
  addModule(soundsLaden);

  /*
   * Diese Funktion spielt den Sound mit dem uebergebenen Dateinamen ab,
   * sofern dieser im Ordner mit den allgemeinen Sounds enthalten ist
   * Wenn der Sound zuvor noch nicht abgespielt wurde, laedt die Funktion ihn erstmal
   * @param dateiname: Der Name der Datei, ohne die Dateiendung, die abgespielt werden soll
   */
  var spieleSound = function(dateiname) {
    if (enthaeltName(allgemeineSounds, dateiname)) {
      createjs.Sound.play(dateiname);
    } else {
      var datei = dateiname + '.mp3';
      var neueDatei = [{
        id: dateiname,
        src: datei
      }];
      allgemeineSounds.push({
        id: dateiname,
        src: datei
      });
      createjs.Sound.on('fileload', soundAbspielen);
      createjs.Sound.registerSounds(neueDatei, allgemeineSoundsPfad);
    }
  };

  /*
   * Diese Funktion spielt den Sound mit dem uebergebenen Dateinamen ab,
   * sofern dieser im Ordner mit den sprachspezifischen Sounds enthalten ist
   * Wenn der Sound zuvor noch nicht abgespielt wurde, laedt die Funktion ihn erstmal
   * @param dateiname: Der Name der Datei, ohne die Dateiendung, die abgespielt werden soll
   */
  var spieleSprachSound = function(dateiname) {
    if (enthaeltName(sprachSounds, dateiname)) {
      createjs.Sound.play(dateiname);
    } else {
      var datei = dateiname + '.mp3';
      var neueDatei = [{
        id: dateiname,
        src: datei
      }];
      sprachSounds.push({
        id: dateiname,
        src: datei
      });
      createjs.Sound.on('fileload', soundAbspielen);
      createjs.Sound.registerSounds(neueDatei, sprachSoundsPfad);
    }
  };

  /*
   * Diese Funktion ueberprueft, ob eine Datei bereichts im Array enthalten ist
   * @param array: Das Array, das ueberprueft werden soll
   * @param name: Der Dateiname, der im Array gesucht werden soll
   */
  var enthaeltName = function(array, name) {
    for (var i = 0; i &lt; array.length; i++) {
      if (array[i].id === name) {
        return true;
      }
    }
    return false;
  };

  /*
   * Diese Funktion wird genutzt, wenn ein Sound geladen wird und danach abgespielt werden soll
   */
  var soundAbspielen = function(event) {
    createjs.Sound.play(event.id);
  };


  /////////////////////////////


  return {
    init: mtlg_init,
    geheZumNaechstenAbschnitt: geheZumNaechstenAbschnitt,
    zumHauptmenue: zumHauptmenue,
    berechneKoordinaten: berechneKoordianten,
    toLocal: toLocal,
    gibStage: gibStage,
    loadOptions: loadOptions,
    gibOptionen: gibOptionen,
    spieleSprachspezifischenSound: spieleSprachSound,
    spieleAllgemeinenSound: spieleSound,
    neuerSpieler: neuerSpieler,
    gibSpielerAnzahl: gibSpielerAnzahl,
    gibSpieler: gibSpieler,
    entferneAlleSpieler: entferneAlleSpieler,
    gibSpielerName: gibSpielerName,
    resize: resize_canvas,
    skaliereUser: scaleUser,
    gibFreienBereich: getBiggestFreeArea,
    addGameInit: addGameInit,
    addModule: addModule,
    bereicheErstellen: bereicheErstellen,
    drawProgress: drawProgress,
  };


})(); //Ende MTLG
</code></pre>
        </article>
    </section>




</div>

<nav>
    <h2><a href="index.html">Home</a></h2><h3>Namespaces</h3><ul><li><a href="MTLG.html">MTLG</a></li></ul>
</nav>

<br class="clear">

<footer>
    Documentation generated by <a href="https://github.com/jsdoc3/jsdoc">JSDoc 3.5.4</a> on Thu Aug 17 2017 19:32:31 GMT+0200 (CEST)
</footer>

<script> prettyPrint(); </script>
<script src="scripts/linenumber.js"> </script>
</body>
</html>
